#!/usr/bin/perl -w
=copyright
	The KJV Bible marked up as HTML (Version 1.1)
	This software is Copyright (C) 2008  Brian Gunlogson

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Affero General Public License as published by
	the Free Software Foundation.

	The HTML/CSS output of this program in herby placed into the Public Domain.
	The JavaScript output of this program is also placed into the Public Domain.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Affero General Public License for more details.

	You should have received a copy of the GNU Affero General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
=cut

package OSISESVParser;

my ($is_making_elemstack, $the_size, $is_printing, $printhandle) = (0, 1, 0, undef);

my $book = undef;
my $chapter = undef;
my $verse = undef;

my @targeted_elems;
my %ays_that_target_targeted_elem; #hash{key=targeted_elem} of arrayrefs{elements=ays_that_target_targeted_elem}

my (@bible_verse_tagstack, %elem_hash);
my ($book_div_ct, $begun_verse, $begun_psalm_hdr, $begun_psalm119_hdr) = (0, 0, 0, 0);

my %books_hash = ( "Gen" => "Genesis", "Exod" => "Exodus", "Lev" => "Leviticus", "Num" => "Numbers", "Deut" => "Deuteronomy", "Josh" => "Joshua", "Judg" => "Judges", "Ruth" => "Ruth", "1Sam" => "1 Samuel", "2Sam" => "2 Samuel", "1Kgs" => "1 Kings", "2Kgs" => "2 Kings", "1Chr" => "1 Chronicles", "2Chr" => "2 Chronicles", "Ezra" => "Ezra", "Neh" => "Nehemiah", "Esth" => "Esther", "Job" => "Job", "Ps" => "Psalms", "Prov" => "Proverbs", "Eccl" => "Ecclesiastes", "Song" => "Song of Solomon", "Isa" => "Isaiah", "Jer" => "Jeremiah", "Lam" => "Lamentations", "Ezek" => "Ezekiel", "Dan" => "Daniel", "Hos" => "Hosea", "Joel" => "Joel", "Amos" => "Amos", "Obad" => "Obadiah", "Jonah" => "Jonah", "Mic" => "Micah", "Nah" => "Nahum", "Hab" => "Habakkuk", "Zeph" => "Zephaniah", "Hag" => "Haggai", "Zech" => "Zechariah", "Mal" => "Malachi", "Matt" => "Matthew", "Mark" => "Mark", "Luke" => "Luke", "John" => "John", "Acts" => "Acts", "Rom" => "Romans", "1Cor" => "1 Corinthians", "2Cor" => "2 Corinthians", "Gal" => "Galatians", "Eph" => "Ephesians", "Phil" => "Philippians", "Col" => "Colossians", "1Thess" => "1 Thessalonians", "2Thess" => "2 Thessalonians", "1Tim" => "1 Timothy", "2Tim" => "2 Timothy", "Titus" => "Titus", "Phlm" => "Philemon", "Heb" => "Hebrews", "Jas" => "James", "1Pet" => "1 Peter", "2Pet" => "2 Peter", "1John" => "1 John", "2John" => "2 John", "3John" => "3 John", "Jude" => "Jude", "Rev" => "Revelation" );
my %rev_books_hash = reverse ( "Gen" => "Genesis", "Exod" => "Exodus", "Lev" => "Leviticus", "Num" => "Numbers", "Deut" => "Deuteronomy", "Josh" => "Joshua", "Judg" => "Judges", "Ruth" => "Ruth", "1Sam" => "1 Samuel", "2Sam" => "2 Samuel", "1Kgs" => "1 Kings", "2Kgs" => "2 Kings", "1Chr" => "1 Chronicles", "2Chr" => "2 Chronicles", "Ezra" => "Ezra", "Neh" => "Nehemiah", "Esth" => "Esther", "Job" => "Job", "Ps" => "Psalms", "Prov" => "Proverbs", "Eccl" => "Ecclesiastes", "Song" => "Song of Solomon", "Isa" => "Isaiah", "Jer" => "Jeremiah", "Lam" => "Lamentations", "Ezek" => "Ezekiel", "Dan" => "Daniel", "Hos" => "Hosea", "Joel" => "Joel", "Amos" => "Amos", "Obad" => "Obadiah", "Jonah" => "Jonah", "Mic" => "Micah", "Nah" => "Nahum", "Hab" => "Habakkuk", "Zeph" => "Zephaniah", "Hag" => "Haggai", "Zech" => "Zechariah", "Mal" => "Malachi", "Matt" => "Matthew", "Mark" => "Mark", "Luke" => "Luke", "John" => "John", "Acts" => "Acts", "Rom" => "Romans", "1Cor" => "1 Corinthians", "2Cor" => "2 Corinthians", "Gal" => "Galatians", "Eph" => "Ephesians", "Phil" => "Philippians", "Col" => "Colossians", "1Thess" => "1 Thessalonians", "2Thess" => "2 Thessalonians", "1Tim" => "1 Timothy", "2Tim" => "2 Timothy", "Titus" => "Titus", "Phlm" => "Philemon", "Heb" => "Hebrews", "Jas" => "James", "1Pet" => "1 Peter", "2Pet" => "2 Peter", "1John" => "1 John", "2John" => "2 John", "3John" => "3 John", "Jude" => "Jude", "Rev" => "Revelation" );
my %chapters_hash = ("Genesis" => 50, "Exodus" => 40, "Leviticus" => 27, "Numbers" => 36, "Deuteronomy" => 34, "Joshua" => 24, "Judges" => 21, "Ruth" => 4, "1 Samuel" => 31, "2 Samuel" => 24, "1 Kings" => 22, "2 Kings" => 25, "1 Chronicles" => 29, "2 Chronicles" => 36, "Ezra" => 10, "Nehemiah" => 13, "Esther" => 10, "Job" => 42, "Psalms" => 150, "Proverbs" => 31, "Ecclesiastes" => 12, "Song of Solomon" => 8, "Isaiah" => 66, "Jeremiah" => 52, "Lamentations" => 5, "Ezekiel" => 48, "Daniel" => 12, "Hosea" => 14, "Joel" => 3, "Amos" => 9, "Obadiah" => 1, "Jonah" => 4, "Micah" => 7, "Nahum" => 3, "Habakkuk" => 3, "Zephaniah" => 3, "Haggai" => 2, "Zechariah" => 14, "Malachi" => 4, "Matthew" => 28, "Mark" => 16, "Luke" => 24, "John" => 21, "Acts" => 28, "Romans" => 16, "1 Corinthians" => 16, "2 Corinthians" => 13, "Galatians" => 6, "Ephesians" => 6, "Philippians" => 4, "Colossians" => 4, "1 Thessalonians" => 5, "2 Thessalonians" => 3, "1 Timothy" => 6, "2 Timothy" => 4, "Titus" => 3, "Philemon" => 1, "Hebrews" => 13, "James" => 5, "1 Peter" => 5, "2 Peter" => 3, "1 John" => 5, "2 John" => 1, "3 John" => 1, "Jude" => 1, "Revelation" => 22);
my @books = ("Genesis", "Exodus", "Leviticus", "Numbers", "Deuteronomy", "Joshua", "Judges", "Ruth", "1 Samuel", "2 Samuel", "1 Kings", "2 Kings", "1 Chronicles", "2 Chronicles", "Ezra", "Nehemiah", "Esther", "Job", "Psalms", "Proverbs", "Ecclesiastes", "Song of Solomon", "Isaiah", "Jeremiah", "Lamentations", "Ezekiel", "Daniel", "Hosea", "Joel", "Amos", "Obadiah", "Jonah", "Micah", "Nahum", "Habakkuk", "Zephaniah", "Haggai", "Zechariah", "Malachi", "Matthew", "Mark", "Luke", "John", "Acts", "Romans", "1 Corinthians", "2 Corinthians", "Galatians", "Ephesians", "Philippians", "Colossians", "1 Thessalonians", "2 Thessalonians", "1 Timothy", "2 Timothy", "Titus", "Philemon", "Hebrews", "James", "1 Peter", "2 Peter", "1 John", "2 John", "3 John", "Jude", "Revelation");

###################
#Exported functions
sub get_elem_hashref
{
	my ($self) = @_;
	die "Can only get elem hash if creating elemstack\n" if(!$is_making_elemstack);
	return \%elem_hash;
}

sub new
{
	my $type = shift;
	$is_making_elemstack = shift if(@_ >= 1);
	$the_size = shift if(@_ >= 1);
	$is_printing = shift if(@_ >= 1);
	return bless {}, $type;
}

############
#SAX callbacks

sub start_element
{
	my ($self, $element) = @_;

=comment
	print "$element->{Name} ";
	foreach(keys %{$element->{Attributes}})
	{
		print $element->{Attributes}->{$_}{Name} . "=" . $element->{Attributes}->{$_}{Value} . " ";
	}
	print "\n";
=cut
	my %attributes;
	foreach(keys %{$element->{Attributes}})
	{
		$attributes{$element->{Attributes}->{$_}{Name}} = $element->{Attributes}->{$_}{Value};
	}
	if(($element->{Name} eq "verse") && defined($attributes{'osisID'}))
	{
		my $tmp_osis = $attributes{'osisID'};
		$tmp_osis =~ /([\w\s]+)[.](\d+)[.](\d+)/;
		my ($tmp_1, $tmp_2, $tmp_3) = ($1, $2, $3);
		if(!defined($book))
		{
			$book_div_ct = 0;
			$book = $tmp_1;
		}
		if(!defined($chapter))
		{
			$chapter = int($tmp_2);
			on_begin_chapter(beautify_chaptername(), beautify_bookname());
		}
		$verse = int($tmp_3);
	} elsif(defined($book) && ($element->{Name} eq "div") && (!(defined($attributes{'type'}) && ($attributes{'type'} eq 'book')))) {
		$book_div_ct++;
		push(@bible_verse_tagstack, { 'Name' => $element->{Name}, 'Attributes' => \%attributes }) if(defined($verse));
	}
	elsif(defined($verse)) {
		if(($element->{Name} eq "milestone") && defined($attributes{'type'}) && ($attributes{'type'} eq 'x-p')) {
			if(is_text_characters())
			{
				if(!$begun_verse) {
					$begun_verse = 1;
					on_begin_verse();
				}
				print_paragraph_sym();
			}
		}	else {
			push(@bible_verse_tagstack, { 'Name' => $element->{Name}, 'Attributes' => \%attributes });
		}
	}
}

sub end_element
{
	my ($self, $element) = @_;

	if($element->{Name} eq "verse") {
		on_end_verse();
		$verse = undef;
		$begun_verse = 0;
	} elsif($element->{Name} eq "chapter") {
		if(defined($chapter))
		{
			on_end_chapter();
			$chapter = undef;
		}
	} elsif($element->{Name} eq "div") {
		if(defined($book))
		{
			if($book_div_ct) {
				$book_div_ct--;
			} else {
				$book = undef;
			}
		}
	}

	my $bible_verse_tagstack_popped_elem = pop(@bible_verse_tagstack);
	if(defined($bible_verse_tagstack_popped_elem))
	{
		#TODO: Anything?
		#NOTE: If not, leave the pop(@bible_verse_tagstack) above
	}

=comment
	print "/$element->{Name}\n";
=cut
}

sub characters
{
	my ($self, $characters) = @_;
	
	my $thechars = $characters->{Data};
	
	if($is_making_elemstack)
	{
		my $completestr = '';

		foreach(@bible_verse_tagstack)
		{
			foreach my $attr (keys %{$_->{'Attributes'}})
			{
				if($attr eq 'lemma') {
					$elem_hash{$_->{'Name'}}{$attr} = 1;
				} else {
					$elem_hash{$_->{'Name'}}{$attr . '=' . $_->{'Attributes'}->{$attr}} = 1;
				}
			}
			$completestr .= $_->{'Name'} . "/";
		}
		
		$elem_hash{$completestr} = 1;
	}
	elsif(defined($verse))
	{
		if(is_psalm119_hdr()) {
			$begun_psalm_hdr = 0;
			if($begun_psalm119_hdr) {
				print {$printhandle} $thechars;
			} else {
				print_psalm119_hdr_begin($thechars);
				$begun_psalm119_hdr = 1;
			}
		} elsif(is_psalm_hdr()) {
			$begun_psalm119_hdr = 0;
			if($begun_psalm_hdr) {
				print {$printhandle} $thechars;
			} else {
				print_psalm_hdr_begin($thechars);
				$begun_psalm_hdr = 1;
			}
		} elsif(is_text_characters()) {
			if($begun_psalm119_hdr) {
				print_psalm119_hdr_end();
				$begun_psalm119_hdr = 0;
			}
			if($begun_psalm_hdr) {
				print_psalm_hdr_end();
				$begun_psalm_hdr = 0;
			}
			if(!$begun_verse) {
				$begun_verse = 1;
				on_begin_verse();
			}
			if(is_inscription()) {
				$thechars = uc($thechars);
			}
			if(is_divine_name()) {
				$thechars = smallcaps_htmlstr($thechars);
			}
			#FIXME: Add <nobr> between hypenated words
			print {$printhandle} $thechars if($is_printing);
		}
	}
}

#########################
#NON SAX helper callbacks

sub add_a_href_target
{
	my ($targeted, $the_a_href) = @_;
	if(!defined($ays_that_target_targeted_elem{$targeted})) {
		$ays_that_target_targeted_elem{$targeted} = [$the_a_href];
	} else {
		push(@{$ays_that_target_targeted_elem{$targeted}}, $the_a_href);
	}
}

sub add_target_id
{
	my ($targeted) = @_;
	push(@targeted_elems, $targeted);
}

sub getprevlnk_htmlstr
{
	my $beautified_bookname = beautify_bookname();
	if($chapter == 1) {
		if($beautified_bookname eq $books[0]) {
			return "<span class=\"prevlnk\">&nbsp;&nbsp;</span>\r\n";
		} else {
			my $prevone;
			foreach(@books)
			{
				if($_ eq $beautified_bookname) {
					my $lastchapter = $chapters_hash{$prevone};
					$prevone = $rev_books_hash{$prevone};
					return "<a class=\"prevlnk\" href=\"$prevone$lastchapter.htm#btt\">&lt;</a>\r\n";
				}
				$prevone = $_;
			}
		}
	}
	my $prevchapter = $chapter-1;
	return "<a class=\"prevlnk\" href=\"$book$prevchapter.htm#btt\">&lt;</a>\r\n";
}

sub getnxtlnk_htmlstr
{
	my $is_id_btt = 0;
	$is_id_btt = shift if(@_ >= 1);
	my $beautified_bookname = beautify_bookname();
	if($chapter == $chapters_hash{$beautified_bookname}) {
		if($beautified_bookname eq $books[@books-1]) {
			return "<span class=\"nxtlnk\"" . ($is_id_btt ? ' id="btt"' : '') . ">&nbsp;&nbsp;</span>\r\n";
		} else {
			my $prevone;
			foreach(reverse @books)
			{
				if($_ eq $beautified_bookname) {
					$prevone = $rev_books_hash{$prevone};
					return "<a class=\"nxtlnk\" href=\"${prevone}1.htm#tpp\"" . ($is_id_btt ? ' id="btt"' : '') . ">&gt;</a>\r\n";
				}
				$prevone = $_;
			}
		}
	}
	my $nxtchapter = $chapter+1;
	return "<a class=\"nxtlnk\" href=\"$book$nxtchapter.htm#ctp\"" . ($is_id_btt ? ' id="btt"' : '') . ">&gt;</a>\r\n";
}

sub beautify_bookname
{
	return $books_hash{$book} if(defined($books_hash{$book}));
	return $book;
}

sub beautify_chaptername
{
	return "PSALM $chapter" if(beautify_bookname() eq "Psalms");
	return "CHAPTER $chapter";
}

sub is_text_characters
{
	my $status = 1;
	foreach(@bible_verse_tagstack)
	{
		if($_->{'Name'} eq 'foreign' || $_->{'Name'} eq 'title' || $_->{'Name'} eq 'note' || (($_->{'Name'} eq 'div') && defined($_->{'Attributes'}->{'type'}) && ($_->{'Attributes'}->{'type'} eq 'colophon'))) {
			$status = 0;
		} elsif(!($_->{'Name'} eq 'divineName' || $_->{'Name'} eq 'inscription' || $_->{'Name'} eq 'w' || $_->{'Name'} eq 'q' || $_->{'Name'} eq 'seg' || $_->{'Name'} eq 'transChange' || ($_->{'Name'} eq 'div' && (!scalar(keys %{$_->{'Attributes'}}))))) {
			die "Tagstack Error\n";
		}
	}
	return $status;
}

sub is_psalm119_hdr
{
	my $status = 0;
	foreach(@bible_verse_tagstack)
	{
		if($_->{'Name'} eq 'foreign') {
			$status = 1;
		} elsif(!($_->{'Name'} eq 'divineName' || $_->{'Name'} eq 'title' || $_->{'Name'} eq 'note' || (($_->{'Name'} eq 'div') && defined($_->{'Attributes'}->{'type'}) && ($_->{'Attributes'}->{'type'} eq 'colophon')) || $_->{'Name'} eq 'inscription' || $_->{'Name'} eq 'w' || $_->{'Name'} eq 'q' || $_->{'Name'} eq 'seg' || $_->{'Name'} eq 'transChange' || ($_->{'Name'} eq 'div' && (!scalar(keys %{$_->{'Attributes'}}))))) {
			die "Tagstack Error\n";
		}
	}
	return $status;
}

sub is_psalm_hdr
{
	return 0 if(is_psalm119_hdr());
	my $status = 0;
	foreach(@bible_verse_tagstack)
	{
		if($_->{'Name'} eq 'title') {
			$status = 1;
		} elsif(!($_->{'Name'} eq 'divineName' || $_->{'Name'} eq 'foreign' || $_->{'Name'} eq 'note' || (($_->{'Name'} eq 'div') && defined($_->{'Attributes'}->{'type'}) && ($_->{'Attributes'}->{'type'} eq 'colophon')) || $_->{'Name'} eq 'inscription' || $_->{'Name'} eq 'w' || $_->{'Name'} eq 'q' || $_->{'Name'} eq 'seg' || $_->{'Name'} eq 'transChange' || ($_->{'Name'} eq 'div' && (!scalar(keys %{$_->{'Attributes'}}))))) {
			die "Tagstack Error\n";
		}
	}
	return $status;
}

sub is_divine_name
{
	#Small caps, except first letter
	my $status = 0;
	foreach(@bible_verse_tagstack)
	{
		if($_->{'Name'} eq 'divineName') {
			$status = 1;
		} elsif(!($_->{'Name'} eq 'title' || $_->{'Name'} eq 'foreign' || $_->{'Name'} eq 'note' || (($_->{'Name'} eq 'div') && defined($_->{'Attributes'}->{'type'}) && ($_->{'Attributes'}->{'type'} eq 'colophon')) || $_->{'Name'} eq 'inscription' || $_->{'Name'} eq 'w' || $_->{'Name'} eq 'q' || $_->{'Name'} eq 'seg' || $_->{'Name'} eq 'transChange' || ($_->{'Name'} eq 'div' && (!scalar(keys %{$_->{'Attributes'}}))))) {
			die "Tagstack Error\n";
		}
	}
	return $status;
}

sub is_inscription
{
	#All caps
	my $status = 0;
	foreach(@bible_verse_tagstack)
	{
		if($_->{'Name'} eq 'inscription') {
			$status = 1;
		} elsif(!($_->{'Name'} eq 'title' || $_->{'Name'} eq 'foreign' || $_->{'Name'} eq 'note' || (($_->{'Name'} eq 'div') && defined($_->{'Attributes'}->{'type'}) && ($_->{'Attributes'}->{'type'} eq 'colophon')) || $_->{'Name'} eq 'divineName' || $_->{'Name'} eq 'w' || $_->{'Name'} eq 'q' || $_->{'Name'} eq 'seg' || $_->{'Name'} eq 'transChange' || ($_->{'Name'} eq 'div' && (!scalar(keys %{$_->{'Attributes'}}))))) {
			die "Tagstack Error\n";
		}
	}
	return $status;
}

sub smallcaps_htmlstr
{
	my ($smallcaps) = @_;
	$smallcaps = uc($smallcaps);
	#FIXME: Make a font? or keep span?
	return substr($smallcaps, 0, 1, '') . '<span class="smallcaps">' . "$smallcaps</span>";
}

sub print_psalm_hdr_begin
{
	my ($psalmhdrtxt) = @_;
	print {$printhandle} '<div class="psalmhdr">' . "$psalmhdrtxt" if($is_printing);
}

sub print_psalm119_hdr_begin
{
	my ($psalm119hdrtxt) = @_;
	print {$printhandle} '<div class="psalm119hdr">' . "$psalm119hdrtxt" if($is_printing);
}

sub print_psalm_hdr_end
{
	print {$printhandle} "</div>\r\n" if($is_printing);
}

sub print_psalm119_hdr_end
{
	print {$printhandle} "</div>\r\n" if($is_printing);
}

sub print_paragraph_sym
{
	print {$printhandle} chr(0x00B6) . ' ' if($is_printing);
}

#NOTE: Do not call before a psalm hdr, set $verse before calling
sub on_begin_verse
{
	add_target_id("v${chapter}_${verse}");
	add_a_href_target("v${chapter}_${verse}", "lnkv${chapter}_${verse}");
	print {$printhandle} '<div class="versetxt" id="v' . $chapter . '_' . $verse . '"><a href="link/' . $book . $chapter . '.htm#v' . $chapter . '_' . $verse . '" id="lnkv' . $chapter . '_' . $verse . '" target="_top" class="versenum">' . "$verse</a> " if($is_printing);
}

sub on_end_verse
{
	print {$printhandle} "</div>\r\n" if($is_printing);
}

sub on_begin_chapter
{
	#$chaptername is eg CHAPTER 1 or PSALM 1
	my ($chaptername, $bookname) = @_;
	if($is_printing)
	{
		open($printhandle, '>', "kjv-iso/kjv/${book}${chapter}.htm") || die "open: $!\n";
		binmode($printhandle, ":utf8");
		print_html_head($bookname);
		print_txtdiv_head($bookname);
		print_chapter($chaptername);
	}
}

sub on_end_chapter
{
	print_txtdiv_footer();
	print_html_footer();
	close($printhandle) || die "close: $!\n";
}

sub print_containerframepages
{
	return if(!$is_printing);

	foreach my $bookname (@books)
	{
		my $book_nospace = $bookname;
		$book_nospace =~ s/\s/&nbsp;/g;
		my $abbrev_book = $rev_books_hash{$bookname};
		my $chapter_cnt = $chapters_hash{$bookname};

		for(my $i = 1; $i <= $chapter_cnt; $i++)
		{
			my $ifrmcthandle;
			open($ifrmcthandle, '>', "kjv-iso/kjv/link/${abbrev_book}${i}.htm") || die "open: $!\n";
			binmode($ifrmcthandle, ":utf8");
			print {$ifrmcthandle} <<EOP;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">\r
<html>\r
<head>\r
<title>Holy Bible</title>\r
<!-- saved from url=(0014)about:internet -->\r
<meta http-equiv="X-UA-Compatible" content="IE=7">\r
<meta http-equiv="content-type" content="text/html; charset=UTF-8">\r
<script type="text/javascript" src="../../scripts/handler.js"></script>\r
<script type="text/javascript" src="../../scripts/cookies.js"></script>\r
<script type="text/javascript" src="../../scripts/lgptfs.js"></script>\r
<script type="text/javascript" src="../../scripts/lgptstc.js"></script>\r
<noscript>\r
<link rel="stylesheet" type="text/css" href="../../scripts/norm.css" title="Normal">\r
<link rel="alternate stylesheet" type="text/css" href="../../scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="../../scripts/huge.css" title="Huge">\r
</noscript>\r
</head>\r
<frameset cols="258,275,223,*">\r
<frame name="lmnufrm" src="../../leftmnu.htm" noresize="noresize" frameborder="0">\r
<frame name="ctframe" src="../${abbrev_book}${i}.htm" noresize="noresize" frameborder="0">\r
<frame name="rmnufrm" src="../../rightmnu.htm" noresize="noresize" frameborder="0">\r
<frame name="blankfrm" src="../../blank.htm" noresize="noresize" frameborder="0">\r
</frameset>\r
</html>\r
EOP
			close($ifrmcthandle) || die "close: $!\n";
		}
	}
}

sub print_rightmnupage
{
	return if(!$is_printing);

	foreach my $bookname (@books)
	{
		my $book_nospace = $bookname;
		$book_nospace =~ s/\s/&nbsp;/g;
		my $abbrev_book = $rev_books_hash{$bookname};

		my $rightmnuhandle;
		open($rightmnuhandle, '>', "kjv-iso/kjv/${abbrev_book}.htm") || die "open: $!\n";
		binmode($rightmnuhandle, ":utf8");
		print {$rightmnuhandle} <<EOP;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\r
<html>\r
<head>\r
<title>Right Menu</title>\r
<!-- saved from url=(0014)about:internet -->\r
<meta http-equiv="X-UA-Compatible" content="IE=7">\r
<meta http-equiv="content-type" content="text/html; charset=UTF-8">\r
<script type="text/javascript" src="../scripts/handler.js"></script>\r
<script type="text/javascript" src="../scripts/cookies.js"></script>\r
<script type="text/javascript" src="../scripts/largeprt.js"></script>\r
<script type="text/javascript" src="../scripts/lgptst.js"></script>\r
<noscript>\r
<link rel="stylesheet" type="text/css" href="../scripts/norm.css" title="Normal">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/huge.css" title="Huge">\r
</noscript>\r
</head>\r
<body>\r
<div class="rightmnupad">\r
EOP
		print_book_chapters($rightmnuhandle, $bookname);
		if($the_size > 3 || $the_size < 1) {
			print {$rightmnuhandle} <<EOP;
<script type="text/javascript" src="../scripts/lgptwr.js"></script>\r
EOP
		}

		print {$rightmnuhandle} <<EOP;
</div>\r
</body>\r
</html>\r
EOP
		close($rightmnuhandle) || die "close: $!\n";
	}
}

sub print_leftmnupage
{
	return if(!$is_printing);
	
	my $leftmnuhandle;
	open($leftmnuhandle, '>', "kjv-iso/leftmnu.htm") || die "open: $!\n";
	binmode($leftmnuhandle, ":utf8");
	print {$leftmnuhandle} <<EOP;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\r
<html>\r
<head>\r
<title>Left Menu</title>\r
<!-- saved from url=(0014)about:internet -->\r
<meta http-equiv="X-UA-Compatible" content="IE=7">\r
<meta http-equiv="content-type" content="text/html; charset=UTF-8">\r
<script type="text/javascript" src="scripts/handler.js"></script>\r
<script type="text/javascript" src="scripts/cookies.js"></script>\r
<script type="text/javascript" src="scripts/lgptstb.js"></script>\r
<noscript>\r
<link rel="stylesheet" type="text/css" href="scripts/norm.css" title="Normal">\r
<link rel="alternate stylesheet" type="text/css" href="scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="scripts/huge.css" title="Huge">\r
</noscript>\r
</head>\r
<body>\r
<div class="leftmnupad">\r
EOP

	foreach my $bookname (@books)
	{
		my $book_nospace = $bookname;
		$book_nospace =~ s/\s/&nbsp;/g;
		my $abbrev_book = $rev_books_hash{$bookname};
		print {$leftmnuhandle} "<a class=\"lnkbk\" href=\"kjv/${abbrev_book}.htm\" target=\"rmnufrm\">$book_nospace</a>&nbsp;&nbsp; ";
	}

	print {$leftmnuhandle} <<EOP;
</div>\r
</body>\r
</html>\r
EOP
	close($leftmnuhandle) || die "close: $!\n";
}

sub print_book_chapters
{
	my $rhandle = shift;
	my $bookname = shift;
	
	return if(!$is_printing);

	my $chapter_cnt = $chapters_hash{$bookname};
	my $abbrev_book = $rev_books_hash{$bookname};
	print {$rhandle} "<div class=\"targetmnupad\">\r\n<div class=\"smallbook\">$bookname [<a class=\"lnkchapter\" href=\"../rightmnu.htm\">X</a>]</div>\r\n";
	for(my $i = 1; $i <= $chapter_cnt; $i++)
	{
		print {$rhandle} "<a class=\"lnkchapter\" href=\"link/${abbrev_book}${i}.htm#tpp\" target=\"_top\">$i</a> ";
	}
	print {$rhandle} "</div>\r\n";
}

sub print_html_footer
{
	return if(!$is_printing);
	print_js_target_handler();
	print {$printhandle} <<EOP;
</body>\r
</html>\r
EOP
}

sub print_txtdiv_footer
{
	return if(!$is_printing);
	print {$printhandle} getnxtlnk_htmlstr(1);
	print {$printhandle} <<EOP;
</div>\r
EOP
}

sub print_html_head
{
	my ($bookname) = @_;
	return if(!$is_printing);
	print {$printhandle} <<EOP;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">\r
<html>\r
<head>\r
<title>$bookname $chapter - KJV</title>\r
<!-- saved from url=(0014)about:internet -->\r
<meta http-equiv="X-UA-Compatible" content="IE=7">\r
<meta http-equiv="content-type" content="text/html; charset=UTF-8">\r
<script type="text/javascript" src="../scripts/handler.js"></script>\r
<script type="text/javascript" src="../scripts/resizejp.js"></script>\r
<script type="text/javascript" src="../scripts/dofrmin.js"></script>\r
<script type="text/javascript" src="../scripts/wheel.js"></script>\r
EOP
	if($the_size == 1) {
		print {$printhandle} <<EOP;
<link rel="stylesheet" type="text/css" href="../scripts/norm.css" title="Normal">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/huge.css" title="Huge">\r
<noscript>\r
EOP
	}	elsif($the_size == 2)	{
		print {$printhandle} <<EOP;
<link rel="stylesheet" type="text/css" href="../scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/norm.css" title="Normal">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/huge.css" title="Huge">\r
<noscript>\r
EOP
	}	elsif($the_size == 3)	{
		print {$printhandle} <<EOP;
<link rel="stylesheet" type="text/css" href="../scripts/huge.css" title="Huge">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/norm.css" title="Normal">\r
<noscript>\r
EOP
	} else {
		print {$printhandle} <<EOP;
<script type="text/javascript" src="../scripts/cookies.js"></script>\r
<script type="text/javascript" src="../scripts/lgptst.js"></script>\r
<noscript>\r
<link rel="stylesheet" type="text/css" href="../scripts/norm.css" title="Normal">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/large.css" title="Large">\r
<link rel="alternate stylesheet" type="text/css" href="../scripts/huge.css" title="Huge">\r
EOP
	}
	print {$printhandle} <<EOP;
</noscript>\r
</head>\r
<body>\r
EOP
}

sub print_js_target_handler
{
	return if(!$is_printing);
	print {$printhandle} <<EOP;
<script type="text/javascript"><!--//--><![CDATA[//><!--\r
function mod_target_elem(el) {\r
	if(IsIE()) {\r
		if(location.hash==("#" + el.id)) {\r
			el.className+=" sftarget";\r
			document.lastTarget=el;\r
		}\r
	}\r
}\r
\r
sfATargeterClick = function(evt) {\r
	var the_this = (evt.srcElement) ? evt.srcElement : evt.target;\r
	if(IsIE()) {\r
		if (document.lastTarget) document.lastTarget.className = document.lastTarget.className.replace(new RegExp(" sftarget\\\\b"), "");\r
		if (the_this.targetEl) the_this.targetEl.className+=" sftarget"; document.lastTarget=the_this.targetEl;\r
	} else {\r
		window.self.location.href="#" + the_this.targetEl.id;\r
	}\r
	return true;\r
}\r
\r
function mod_a_targeter(el,the_a_targeter) {\r
	var the_a_that_targets_targeted_elem = document.getElementById(the_a_targeter);\r
	the_a_that_targets_targeted_elem.targetEl = el;\r
	the_a_that_targets_targeted_elem.sfATargeterClickHdlr = sfATargeterClick;\r
	XBrowserAddHandler(the_a_that_targets_targeted_elem,'click','sfATargeterClickHdlr');\r
}\r
\r
sfTargetNonStatic = function() {\r
	var the_targeted_elem = null;\r
EOP
	my %tmp_tgt_elems_lookup;
	foreach my $targeted_elem (@targeted_elems)
	{
		$tmp_tgt_elems_lookup{$targeted_elem} = 1;
		print {$printhandle} <<EOP;
	the_targeted_elem = document.getElementById('$targeted_elem');\r
	mod_target_elem(the_targeted_elem);\r
EOP
		foreach my $a_that_targets_targeted_elem (@{$ays_that_target_targeted_elem{$targeted_elem}})
		{
			print {$printhandle} <<EOP;
	mod_a_targeter(the_targeted_elem, '$a_that_targets_targeted_elem');\r
EOP
		}
	}
	foreach my $targeted_elem (keys %ays_that_target_targeted_elem)
	{
		next if(defined($tmp_tgt_elems_lookup{$targeted_elem}));
		print {$printhandle} <<EOP;
	the_targeted_elem = document.getElementById('$targeted_elem');\r
EOP
		foreach my $a_that_targets_targeted_elem (@{$ays_that_target_targeted_elem{$targeted_elem}})
		{
			print {$printhandle} <<EOP;
	mod_a_targeter(the_targeted_elem, '$a_that_targets_targeted_elem');\r
EOP
		}
	}
	%tmp_tgt_elems_lookup = ();
	@targeted_elems = ();
	%ays_that_target_targeted_elem = ();
	print {$printhandle} <<EOP;
}\r
\r
document.lastTarget = null;\r
window.sfTargetNonStaticHdlr = sfTargetNonStatic;\r
XBrowserAddHandler(window,'load','sfTargetNonStaticHdlr');\r
\r
//--><!]]></script>\r
EOP
}

sub print_txtdiv_head
{
	my ($bookname) = @_;
	return if(!$is_printing);
	#add_target_id("tpp");
	print {$printhandle} <<EOP;
<div class="txtpad">\r
<div class="book" id="tpp">$bookname</div>\r
EOP
}

sub print_chapter
{
	my ($chaptername) = @_;
	return if(!$is_printing);
	print {$printhandle} getprevlnk_htmlstr() . "<span class=\"nxtlnk\">&nbsp;&nbsp;</span>\r\n";
	print {$printhandle} <<EOP;
<div class="chapter" id="ctp">$chaptername</div>\r
EOP
}

package main;

use strict;
use XML::SAX::ParserFactory;
use XML::SAX::ExpatXS;

sub system_or_die
{
	die "system(" . $_[0] . ") failed: $!\n" if(system($_[0]));
}

sub print_license
{
	print <<EOF;
htmlizekjv.pl version 1.1

Copyright (C) 2008  Brian Gunlogson
This program comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it
under certain conditions. License: GNU AGPL version 3

EOF
}

sub print_useage
{
	print <<EOF;
Tested with Perl 5.8.8.
Requires:
	XML::SAX perl module.
	CrossWire's 'mod2osis' utility in the path.
		From The SWORD Project source distribution.
	CrossWire KJV OSIS SWORD module.
	mkisofs

Place the script into a user writable directory with plenty of free space.
./htmlizekjv.pl -r

Useage: htmlizekjv.pl -r
-r run program

EOF
}

my ($display_usage, $run_prog) = (1, 0);
foreach(@ARGV)
{
	if($_ eq '-r') {
		$run_prog = 1;
		$display_usage = 0;
	}
}

print_license();
print_useage() if($display_usage);

if($run_prog) {

#TODO: DOCUMENT $i: it basically has 4 classes that defines the output CSS order for hardcoded print sizes
#NOTE: $i = 0 means to output all 3 sizes using javascript to switch between
for(my $i = 0; $i <= 0; $i++) #$i <= 3
{
	system("rm -rf kjv-iso");
	system("rm kjv${i}.iso");

	mkdir("kjv-iso");
	mkdir("kjv-iso/kjv");
	mkdir("kjv-iso/kjv/link");

	system_or_die("cp support-files/autorun.inf kjv-iso/autorun.inf");
	system_or_die("cp support-files/autorun.ico kjv-iso/autorun.ico");
	system_or_die("cp support-files/rightmnu.htm kjv-iso/rightmnu.htm");
	system_or_die("cp support-files/bible.htm kjv-iso/bible.htm");
	system_or_die("cp support-files/biblem${i}.htm kjv-iso/biblem.htm");
	system_or_die("cp support-files/blank.htm kjv-iso/blank.htm");
	system_or_die("cp -a support-files/scripts kjv-iso/scripts");

	if(-f "./kjv.tmp.xmlblob") {
		warn "Skipping creation of kjv.tmp.xmlblob\nDelete the file if you want it recreated\n";
	} else {
		system_or_die("mod2osis KJV > ./kjv.tmp.xmlblob");
	}
	my $handler = OSISESVParser->new(0, $i, 1);
	$handler->print_leftmnupage();
	$handler->print_rightmnupage();
	$handler->print_containerframepages();
	my $parser = XML::SAX::ParserFactory->parser( Handler => $handler );
	$parser->parse_file("./kjv.tmp.xmlblob");

	system_or_die("mv kjv-iso kjv-iso${i}");
}

=elemstack
foreach(keys %{$handler->get_elem_hashref()})
{
	if($handler->get_elem_hashref()->{$_} == 1)
	{
		print "$_\n";
	}
	else
	{
		print "$_: ";
		foreach my $attr_key (keys %{$handler->get_elem_hashref()->{$_}})
		{
			print "$attr_key, ";
		}
		print "\n";
	}
}
=cut

}
